module BeanstalkFarmer
  # @private Provides a clean slate object that we can safely instance eval on.
  class DSL
    attr_accessor :handler_pool

    def initialize(handler_pool)
      self.handler_pool = handler_pool
    end

    def eval(&block)
      instance_eval &block
    end

    def tube(tube_name, job_handler=nil, &block)
      job_handler = block.to_proc if block_given?
      handler_pool[tube_name] = job_handler
    end
  end
end
